image: node:lts-bullseye

stages:
  - test
  - build
  - deploy

.cache_template: &cache_definition
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - node_modules/
    - ~/.cache/ms-playwright

test:
  needs: []
  cache: *cache_definition
  before_script:
    - npm ci
    - npx playwright install-deps
  script:
    - npm test

build:lib:
  stage: build
  needs: []
  cache: *cache_definition
  artifacts:
    expire_in: 1 day
    paths:
      - lib
      - LICENSE
      - package.json
      - package-lock.json
      - README.md
  before_script:
    - rm -rf ./src/stories
    - rm -rf ./src/testing
    - find ./src -name "*.test.ts" -type f -delete
    - npm ci
  script:
    - npm run build

build:pages:
  stage: build
  needs: []
  cache: *cache_definition
  artifacts:
    expire_in: 1 day
    paths:
      - public
  before_script:
    - npm ci
  script:
    - npm run build-api
    - npm run build-storybook
    - mkdir public
    - mv api public/api
    - mv storybook-static public/storybook

pages:
  stage: deploy
  only: [tags]
  needs:
    - build:pages
  dependencies:
    - build:pages
  artifacts:
    expire_in: 1 day
    paths:
      - public
  variables:
    GIT_STRATEGY: none
  script:
    - echo "Deploying pages"

publish:
  stage: deploy
  only: [tags]
  needs:
    - build:lib
    - test
  dependencies:
    - build:lib
  variables:
    GIT_STRATEGY: none
  script:
    - echo "//registry.npmjs.org/:_authToken=${NPM_TOKEN}" > ~/.npmrc
    - npm version "${CI_COMMIT_TAG}" --allow-same-version --no-commit-hooks --no-git-tag-version
    - npm publish
